#include "Pole.h"
#include <time.h>
#include <stdlib.h>

// destruktor
Pole::~Pole()
{
	SmazPole();
}

void Pole::SmazPole()
{
	if (pole!=NULL)
	{
		delete[] pole;
		pole = NULL;
		pocetPrvku=0;
	}
}

void Pole::NactiHodnoty(istream &odkud)
{
	int i;
	if (odkud==cin) cout << endl << "Celkem " << pocetPrvku << " hodnot";
	for (i=0; i<pocetPrvku; ++i)
	{
		if (odkud==cin) cout << "Zadej " << i+1 << ". hodnotu:";
		odkud >> pole[i];
	}
	if (odkud==cin) cout << endl << "Dekuji za zadani hodnot ;o)";
}

Pole::Pole(const Pole& vzor)
{
	pocetPrvku = vzor.pocetPrvku;
	pole = new int[pocetPrvku];
	for (int i=0; i<pocetPrvku; ++i) 
	{
		pole[i]=vzor.pole[i];
	}
}

Pole::Pole(int pocetPrvku)
{
	if (pocetPrvku<=0) pocetPrvku =5;// osetrime spatny vstup
	pole = new int[pocetPrvku];
	this->pocetPrvku = pocetPrvku;
	for (int i=0; i<pocetPrvku;++i) pole[i]=0;
}

void Pole::PrictiPole(const Pole &co)
{
	int pricistPrvku;
	if (pocetPrvku < co.pocetPrvku) ZmenPocetPrvku(co.pocetPrvku);
	pricistPrvku = (pocetPrvku >co.pocetPrvku)?co.pocetPrvku: pocetPrvku;
	for (int i=0; i< pricistPrvku; ++i) 
	{
		pole[i] = co.pole[i];
	}
}

void Pole::VygenerujHodnoty(int min, int max) 
{
	time_t cas;
	srand((unsigned)(time(&cas)));
	for (int i=0; i<pocetPrvku; ++i) 
	{
		pole[i]=rand() % (max-min+1) + min;
	}
}

void Pole::VypisHodnoty(ostream &kam)
{
	kam << endl;
	kam << "Pocet hodnot: " << pocetPrvku;
	for (int i=0; i<pocetPrvku; ++i)
	{
		kam << endl << "Hodnota " << i+1 << ".=" << pole[i];
	}
}	

void Pole::ZmenPocetPrvku(int novyPocetPrvku)
{
	int *novePole;
	int prekopirovatPrvku;
	novePole=new int[novyPocetPrvku];
	prekopirovatPrvku = (novyPocetPrvku<pocetPrvku)?novyPocetPrvku:pocetPrvku;
	for (int i=0; i<prekopirovatPrvku; ++i)
	{
		novePole[i]=pole[i];
	}
	delete[] pole;
	pole = novePole;
}